from Tkinter import *

import sys, os, thread
import time

def create_command_frame(title=''):
    """Automatically starts a new thread then waits for 1 second to allow for
    the frame to fully initialize before printing is done
    """
    thread.start_new_thread(command_line, (title,))

    time.sleep(1)
    
def end():
    """This is needed to keep the frame alive until the terminate button is hit
    """
    while 1:
       time.sleep(.1)
class command_line(Frame):
    def __c__(self, event=None):
        print 'exit'
        os._exit(0)
                
    def build_widgets(self):
        self.text1 = Text(self)
        self.text1.pack(side=BOTTOM)
        self.text1.see(END)
        self.text1.config(state=DISABLED)
        self.b = Button(self, text='Terminate', command=self.__c__)
        self.b.pack(side=TOP);
        
    def clear(self):
        self.text1.config(state=NORMAL)
    	self.text1.delete(1.0, END)
    	self.text1.config(state=DISABLED)

    def write(self, txt):
        self.text1.config(state=NORMAL)
        self.text1.insert(INSERT, txt)
        self.text1.see(END)
        self.text1.config(state=DISABLED)
            
    def __init__(self, t=''):
        self.master = Tk()
        Frame.__init__(self, self.master)
        self.pack()
        self.build_widgets()
        sys.stdout = self
        if '--debug' not in sys.argv:
            sys.stderr = self
        self.master.title(t)
        self.master.mainloop()
