#    progressbar.py
#    gibbs
#
#
#    Created by Thomas Cool on 1-Sept-2009.
#    Copyright 2009 Thomas Cool, R. Edwin Garcia
#    This file is part of gibbs.
#
#    gibbs is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Foobar is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
#

from clprogressbar import ProgressBar as ProgressBarCL
from tkprogressbar import ProgressBar as ProgressBarTK
import utils
import sys



class ProgressBar:
    def __init__(self,type='TK',min=0,max=100,varSTR=None):
        self.closed=False
        if type not in ['TK',None,'None','CLI','tk','cli']:
            self.type=None
        else:
            self.type=type
        if max<min:
            print 'error ... not catastrophical\nnot showing progress bar'
            self.type==None
        else:
            self.min=min
            self.max=max
        self.varSTR=varSTR
        if self.type=='CLI' or self.type=='cli' :
            self.oldval=0.0
            self.prog = ProgressBarCL(min, max,utils.screenwidth(),mode='fixed',char='#')
        elif self.type=='TK' or self.type=='tk':
            self.prog = ProgressBarTK(400,30)
        
            
    def __call__(self,newVal=None): 
        if newVal==None:
            self.close()
        elif self.closed==False:
            if self.type==None:
                return
            elif self.type=='TK' or self.type=='tk':
                self.prog.update(float(newVal-self.min)/float((self.max-self.min)))
            elif self.type=='CLI' or self.type=='cli':
                stepsize=newVal-self.oldval
                self.oldval=newVal
                oldprog = str(self.prog)
                self.prog.increment_amount(stepsize)
                if oldprog != str(self.prog):
                    sys.stdout.flush()
                    oldprog=str(self.prog)
        else:
            print 'was closed'
                    
    def close(self):
        self.closed==True
        if self.type=='TK' or self.type=='tk':
            self.prog.close()
            del self.prog
            
        