#
#
#    Created by Thomas Cool on 1-Sept-2009.
#    Copyright 2009 Thomas Cool, R. Edwin Garcia
#    This file is part of gibbs.
#
#    gibbs is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Foobar is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
#
from pylab import figure,show,draw
from numpy import cos, sin, pi
ticks=4
a=figure(1)
b=a.add_subplot('111')
x=[0,0.5,1,0]
y=[0,sin(pi/3),0,0]
b.plot(x,y,'k')
b.set_axis_off()
draw()
b.set_xticks([])
b.set_yticks([])
b.set_ylim([min(y)-0.1,max(y)+0.1])
b.set_xlim([min(x)-0.1,max(x)+0.1])
b.text(0.5,min(y)-0.05,'$x_1$',color='y',horizontalalignment='center')
b.text(min(x)+0.2,(max(y)-min(y))/2.0,'$x_2$',color='b',horizontalalignment='center',rotation=60)
b.text(max(x)-0.2,(max(y)-min(y))/2.0,'$x_3$',color='m',horizontalalignment='center',rotation=300)
xrange=max(x)-min(x)
for i in range(ticks+1):
    index=float(i)*xrange/ticks
    b.plot([index,index],[min(x),min(x)-0.01],'k')
    b.text(index,min(x)-0.01,float(i)/ticks,color='y')
print 'max y:',max(y)
for i in range(ticks+1):
    yindex=float(i)*sin(pi/3)/ticks
    xindex=float(i)*cos(pi/3)/ticks
    b.plot([xindex,xindex-0.01*cos(pi/6)],[yindex,yindex+0.01*sin(pi/6)],'k')
    b.text(xindex-0.01*cos(pi/6),yindex+0.01*sin(pi/6),str(1.0-float(i)/ticks),color='b')
    b.text(max(x)-(xindex-0.01*cos(pi/6)),yindex+0.01*sin(pi/6),str(float(i)/ticks),color='m')
    b.plot([max(x)-xindex,max(x)-(xindex-0.01*cos(pi/6))],[yindex,yindex+0.01*sin(pi/6)],'k')
    b.plot([xindex,max(x)-xindex],[yindex,yindex],':m')
    b.plot([xindex,float(i)*xrange/ticks],[yindex,min(x)],':b')
    b.plot([max(x)-xindex,max(x)-float(i)*xrange/ticks],[yindex,min(x)],':y')

#point (0.5,0.5,0)
c=[0.5,0.5]
yval=(1-c[0]-c[1])*(max(y)-min(y))
xval=c[0]+(1-c[0]-c[1])*cos(pi/3)
b.plot(xval,yval,'or')

c=[0.3,0.2]
yval=(1-c[0]-c[1])*(max(y)-min(y))
xval=c[0]+(1-c[0]-c[1])*cos(pi/3)
b.plot(xval,yval,'or')




draw()
show()
a.savefig('1.eps')