from sympy import Symbol
from sympy.core.basic import Basic

class Variable(Basic):
    
    def __new__(cls, name):
        if isinstance(name, Basic):
            obj = Basic.__new__(cls)
            obj.name = name
            return obj
        else:
            return Symbol(name)
    
    def __call__(self, **kwds):
        eq = [self.name]
        result = []
        for key in kwds:
            if type(kwds[key]) in (type(1), type(1.)):
                kwds[key] = [kwds[key]]
            
            if len(eq)>1 and len(kwds[key])>1:
                sequence = kwds[key]
                for i in range(len(eq)):
                    temp = eq[i]._subs_old_new(key, sequence[i])
                    result.append(temp)
            else:
                for i in range(len(eq)):
                    for sequence in kwds[key]:
                        temp = eq[i]._subs_old_new(key, sequence)
                        result.append(temp)
            eq = result
            result = []
        if len(eq)==1:
            eq = eq[0]
        return eq
        
        
                
        

   
        
        

    
        
        
        
    

        
        
        
        

  
        
        
        
        

        
    
            
            
        
        

        
        
    


        
        

    
        
        
        
        
            

        
            
