/*
 *  QHRegularGeneratorC.c
 *  Swig_Test
 *
 *  Created by Thomas Cool on 9/30/09.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */

#include "QHRegularGeneratorC.h"

double xlogx (double a)
{
	
	if  (a==0.0)
	{//printf("!!");
        return 0;}
	else if (a == 1.0)
	{	//printf("@@");
        return 0;}
	else if( a>0 && a<1)
		//printf(" value %f %f\n",a, log(a));
		return a*log(a);
	return 0.0;
}
double getDouble (double *a,int b)
{
	return a[b];
}
void setDouble(double *a, int index, double value)
{
	a[index]=value;
	//return 0;
	
}
int calculateFreeEnergy(double *points, double *freeEnergy, int totalmax, int nb_pts, int elt_number, semi_reg_struct phase, double Temp )
{
	double R=8.314;
	int i;
	for(i=0;i<nb_pts;i++)
	{
		int index = i + elt_number*nb_pts;
		if(i==(nb_pts-1))
		{
			freeEnergy[index]= phase.delta_Hb-(Temp*phase.delta_Hb/phase.temp_m_b);
		}
		else
		{
			freeEnergy[index] = phase.omega * points[index] *(1.0-points[index])+R*Temp* (xlogx(points[index])+xlogx(1.0-points[index]) )+ (1.0-points[index])*(phase.delta_Ha - Temp*phase.delta_Ha/phase.temp_m_a)+points[index]*(phase.delta_Hb-Temp*phase.delta_Hb/phase.temp_m_b);
            //printf("%lf %lf\n",points[index],freeEnergy[index]);
		}
	}
	return 0;
}
semi_reg_struct setPhase(double omega, double delta_Ha, double delta_Hb, double temp_m_a, double temp_m_b)
{
	reg_struct b;
	b.delta_Ha=delta_Ha;
	b.delta_Hb=delta_Hb;
	b.temp_m_a=temp_m_a;
	b.temp_m_b=temp_m_b;
	b.omega=omega;
	return b;
}
