#
#  QHTest.py
#  Swig_Test
#
#  Created by Thomas on 9/18/09.
#  Copyright (c) 2009 __MyCompanyName__. All rights reserved.
#
from QHSolver import QHSolver
if __name__ == '__main__':
	import time
	t1=time.time()
	a=QHSolver(pointsPerElement=200,maxPhaseTemp=1500,phaseCalculations=100)
	a.addMaterial(-22880,11940,24263,1329,2135)
	a.addMaterial(247,0,7280,4000,-3000)
	a.addMaterial(30309,3877,10000,4525,5400)
	x=Symbol('x')
	R=Symbol('R')
	Temp=Symbol('Temp')
	omega=Symbol('omega')
	delta_Ha=Symbol('delta_Ha')
	delta_Hb=Symbol('delta_Hb')
	Tma=Symbol('Tma')
	Tmb=Symbol('Tmb')
        DG = omega * x *(1.0-x)+R*Temp* (xlogx(x)+xlogx(1.0-x) )+ (1.0-x)*(delta_Ha - Temp*delta_Ha/Tma)+x*(delta_Hb-Temp*delta_Hb/Tmb);

	#DG=omega * x *(1.0-x)+R*Temp+ xlogx(1.0-x)*(delta_Ha - Temp*delta_Ha/Tma)+x*(delta_Hb-Temp*delta_Hb/Tmb)
        #print DG
	a.solvePhase(DG=DG)

	t2=time.time()
	b=QHSolver(pointsPerElement=200,maxPhaseTemp=1450,minPhaseTemp=300,phaseCalculations=300,)
	b.addMaterial(-22880,11940,24263,1329,2135,omegap=2000)
	#a.addMaterial(247,0,7280,4000,-3000)
	b.addMaterial(30309,3877,10000,4525,5400)
	b.solvePhase()
	t3=time.time()

	c=QHSolver(pointsPerElement=200,maxPhaseTemp=6000,minPhaseTemp=600,phaseCalculations=300,)
	#c.addMaterial(-22880,11940,24263,1329,2135)
	c.addMaterial(247,0,7280,4000,-3000)
	c.addMaterial(30309,3877,10000,4525,5400,omegaz=3000)
	c.solvePhase()
	t4=time.time()
    
        #a.solve(DG=DG)
	#a.printPhaseDiagram()
	#b.printPhaseDiagram()
	#c.printPhaseDiagram()

	print 'time to run 1: '+str(t2-t1)
	print 'time to run 2: '+str(t3-t2)
	print 'time to run 4: '+str(t4-t3)