from gibbs.solvers.qhsolver.qhsolvercore import QHSolverCore


class QHTernarySolver(QHSolverCore):
    def __init__(self,x=[0,1,200],y=[yVal],DG=None,variables=None,x2=0.0,ProgressBar='CLI',**kwargs):
        QHSolveCore.__init__(x=x,y=y,DG=DG,variables=variables,PB=ProgressBar)
        self.x2=x2
    
    def _calculate(self,points,yVal,varY,varX,stepsLoopX,x2):
        #calcArray=QHSolve.new_doubleArrayFct(stepsLoopX*len(self.DG))
        from numpy import zeros
        calcArray=zeros(stepsLoopX*len(self.DG),'d')
        for i in range(len(self.DG)):

            self.DG[i].evalf(freeEnergyArray=calcArray,points=points,arraylength=stepsLoopX*len(self.DG),xsteps=stepsLoopX,phaseNumber=i,x_two=x2,varX=varX,varY=varY,yVal=yVal)
        return calcArray
