from gibbs.tools.sympyfunctions import *
from numpy import arange, array
from gibbs.variables import Variable
from sympy import Matrix

x=Variable('x')
R=Variable('R')
Temp=Variable('Temp')
omega=Variable('omega')
delta_Ha=Variable('delta_Ha')
delta_Hb=Variable('delta_Hb')
Tma=Variable('Tma')
Tmb=Variable('Tmb')
import time
t1 = time.time()
#free energy functions
#for i in range(10):
DG1=Variable(omega*x*(1.0-x)+R*Temp*(xlogx(x)+xlogx(1.0-x))+(1.0-x)*(delta_Ha-Temp*delta_Ha/Tma)+x*(delta_Hb-Temp*delta_Hb/Tmb))
DG1=DG1(omega=-22880,R=8.314,delta_Ha=11940,delta_Hb=24263,Tma=1329,Tmb=2135,Temp=1000)
x=arange(0.1,1.0,0.001)
DG1=Variable(DG1)
c=DG1(x=x)
#for i in range(len(c)):
#	c[i]=c[i].evalf()
c=Matrix(c)
t2=time.time()
print t2-t1
