#
#  QHSolverGUI.py
#  Swig_Test
#
#  Created by Thomas on 9/26/09.
#  Copyright (c) 2009 __MyCompanyName__. All rights reserved.
#
import VKML.gui as VKMLgui

from gibbs.variables.variable import Variable
from gibbs.solvers.qhsolver import QHSolver
def hello(Min_Var_One):
    print Min_Var_One
def hello2(**kwargs):
    #print DGList
    #print PBStyle
    args={}
    for i in VarNames:
        args[i]=kwargs[i]
    DG=[]
    #print args
    for i in range(len(DGList)):
        tempVar = Variable(DGList[i])
        DG.append(tempVar(**args))
    #print DG
    variables=[[VarNameOne,kwargs['Min_Var_One'],kwargs['Max_Var_One'],kwargs['Steps_Var_One']],[VarNameTwo,kwargs['Min_Var_Two'],kwargs['Max_Var_Two'],kwargs['Steps_Var_Two']]]
    print variables
    b=QHSolver(DG=DG,variables=variables,PB=PBStyle)
    b.printPhaseDiagram()
        
        
    
def QHSolverGUI(DG,variables=[],PB='TK',**kwargs):
    global DGList
    DGList=DG
    global PBStyle
    PBStyle = PB
    global VarNameOne
    try:
        VarNameOne=variables[0][0]
    except:
        VarNameOne= 'x'
    global VarNameTwo
    try:
        VarNameTwo=variables[1][0]
    except:
        VarNameTwo='Temp'
    p=VKMLgui.Parser(title='QHSolver',interactive=-1)
    
    
    
    m1=VKMLgui.Menu(title='x Properties',parser=p)


    try:
        tempVal=variables[0][1]
    except:
        tempVal=0
    VKMLgui.Parameter(name='Min_Var_One',menu=m1,default=tempVal,variable=int)
    
    try:
        tempVal=variables[0][2]
    except:
        tempVal=1
        
    VKMLgui.Parameter(name='Max_Var_One',menu=m1,default=tempVal,variable=int)
    
    try:
        tempVal=variables[0][3]
    except:
        tempVal=200
        
    VKMLgui.Parameter(name='Steps_Var_One',menu=m1,default=200,variable=int,interval=(1,1000))
    
    
    
    m2=VKMLgui.Menu(title='y Properties',parser=p)
    try:
        tempVal=variables[1][1]
    except:
        tempVal=300
    VKMLgui.Parameter(name='Min_Var_Two',menu=m2,default=tempVal,variable=int,interval=(0,10000))
    
    try:
        tempVal=variables[1][2]
    except:
        tempVal=1300
        
    VKMLgui.Parameter(name='Max_Var_Two',menu=m2,default=tempVal,variable=int,interval=(0,10000)) 
       
    try:
        tempVal=variables[1][3]
    except:
        tempVal=200

    VKMLgui.Parameter(name='Steps_Var_Two',menu=m2,default=tempVal,variable=int,interval=(0,1000))
    
    global VarNames
    VarNames=[]
    if len(variables)>2:
        m3=VKMLgui.Menu(title='Misc Properties',parser=p)
        for i in range(len(variables)-2):
            tempName=str(variables[i+2][0])
            if len(variables[i+2])==2:
                defaultV=variables[i+2][1]
                min=defaultV-100
                max=defaultV+100
            elif len(variables[i+2])==1:
                defaultV=50
                min=-50
                max=150
            elif len(variables[i+2])==3:
                min=variables[i+2][1]
                max=variables[i+2][2]
                defaultV=float(min+max)/2
            elif len(variables[i+2])==4:
                min=variables[i+2][1]
                max=variables[i+2][2]
                defaultV=variables[i+2][3]
            VarNames.append(tempName)
            VKMLgui.Parameter(name=tempName,menu=m3,default=defaultV,variable=float,interval=(min,max))
    m4=VKMLgui.Menu(title='General Settings',parser=p)
    m5=VKMLgui.Menu(title='Saving',parser=p)

    VKMLgui.Parameter(name='save',menu=m5,variable=bool,default=False)
    VKMLgui.Parameter(name='save_Path',menu=m5,variable=str,default="~/")
    VKMLgui.Parameter(name='save_Name',menu=m5,variable=str,default="")
    VKMLgui.Parameter(name='title',menu=m5,variable=str,default="")

    VKMLgui.Parameter(name='show',menu=m5,variable=bool,default=True)
    p.add_command(hello)
    p.add_command(hello2)
    p.run()
