//    QHDataFileVariableMethods.i
//    gibbs
//
//
//    Created by Thomas Cool on 1-Sept-2009.
//    Copyright 2009 Thomas Cool, R. Edwin Garcia
//    This file is part of gibbs.
//
//    gibbs is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    gibbs is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
%module QHDataFileVariableMethods

%{
#define SWIG_FILE_WITH_INIT
#include "QHDataFileVariableMethods.h"
    %}

%include "numpy.i"

%init %{
    import_array();
    %}

//%apply (double* INPLACE_ARRAY1, int DIM1) {(double* points, int len),(double *freeEnergy,int lenn)}
%apply (double* INPLACE_ARRAY1, int DIM1) {(double* xdata, int xdataLen),(double* ydata,int ydataLen),(double *fxdata,int fxdataLen),(double *fydata, int fydataLen)}
%apply (double* INPLACE_ARRAY1, int DIM1) {(double* xdata, int xdataLen),
    (double* ydata,int ydataLen),
    (double *fxdataU,int fxdataLenU),
    (double *fydataU, int fydataLenU),
    (double *fxdataA,int fxdataLenA),
    (double *fydataA, int fydataLenA)}
%include "carrays.i"
%include "QHDataFileVariableMethods.h"